/**
Solutie O(N+M) Inelus Gabriel-Robert
*/
#include <bits/stdc++.h>

#define Nmax 666013
using namespace std;

vector<int> G[Nmax];
int Q[Nmax],pq,uq;
int color[Nmax],N,M;
bool bad = false;

void Read_Input(void){
    scanf("%d%d",&N,&M);
    int a,b;
    for(int i = 1; i <= M; ++i){
        scanf("%d%d",&a,&b);
        G[a].push_back(b);
        G[b].push_back(a);
    }
}

void Bipartite(){
    int k = 1;
    Q[++uq] = k;
    color[k] = 1;
    while(pq <= uq){
        if(bad)
            return;
        k = Q[pq++];
        for(auto it : G[k])
            if(color[it] == 0){
                color[it] = 3 - color[k];
                Q[++uq] = it;
            }
            else if( color[it] != 3 - color[k])
                    {bad = true;break;}
    }
    for(int i = 1; i <= N; ++i)
        if(color[i] == 0)
            bad = true;
}

void Print(){
    for(int i = 1; i <= N; ++i)
        if(color[i] == 1)
            printf("%d ",i);
    printf("\n");
    for(int i = 1; i <= N; ++i)
        if(color[i] != 1)
            printf("%d ",i);
    printf("\n");
}

int main(){
    freopen("hogwarts.in","r",stdin);
    freopen("hogwarts.ok","w",stdout);
    Read_Input();
    Bipartite();
    if(bad == false)
        Print();
    else
        printf("-1\n");
    return 0;
}
