/**
    20p O(N^2)
*/
#include <bits/stdc++.h>

#define Nmax 2005
#define Kmax 4000005
using namespace std;

int N, K;
int DP[Nmax][Nmax],used[Nmax][Nmax];
int Size[Kmax],ncc;
queue<pair<int,int> > Q;

const int dx[4] ={0,0,1,-1},
          dy[4] ={1,-1,0,0};

void Read(){
    scanf("%d%d",&N,&K);
    int a,b;
    for(int i = 1; i <= K; ++i){
        scanf("%d%d",&a,&b);
        DP[a][b] = 1;
    }
}

int BFS(int i,int j){
    Q.push({i,j});
    used[i][j] = 1;
    int cnt = 1;
    while(!Q.empty())
    {
        auto k = Q.front();
        i = k.first;
        j = k.second;
        Q.pop();
        if(DP[i][j] == 0)
            continue;
        for(int k = 0; k <= 3; ++k)
            if(!used[i+dx[k]][j+dy[k]] && DP[i+dx[k]][j +dy[k]] == 1)
            {
                ++cnt;
                used[i+dx[k]][j+dy[k]] = 1;
                Q.push({i+dx[k],j+dy[k]});
            }
    }
    return cnt;
}

int cnt[Kmax];

void Solve(){
    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
            if(!used[i][j] && DP[i][j] == 1){
                ++ncc;
                Size[ncc] = BFS(i,j);
            }
    printf("%d\n",ncc);
    for(int i = 1; i <= ncc; ++i)
        cnt[Size[i]]++;
    for(int i = 1; i <= K; ++i)
        if(cnt[i])
            printf("%d %d\n",i,cnt[i]);
}

int main(){

    freopen("mozaic.in","r",stdin);
    freopen("mozaic.out","w",stdout);

    Read();
    Solve();

    return 0;
}
